#include "../../../include/http/pages/homepage.h"
#include "../../../include/stringfunctions.h"
#include "../../../include/global.h"

#ifdef XMEM
	#include <xmem.h>
#endif

const std::string HomePage::GeneratePage(const std::string &method, const std::map<std::string,std::string> &queryvars)
{

	std::string messagecountstr="";
	std::string filecountstr="";

	if(queryvars.find("formaction")!=queryvars.end() && (*queryvars.find("formaction")).second=="shutdown")
	{
		wantshutdown=true;
	}

	std::string content="<h2>Home</h2>";
	content+="<p class=\"paragraph\">";
	content+="<b>FMS version ";
	content+=FMS_VERSION;
	content+="</b><br>";
	content+="Use these pages to administer your FMS installation.";
	content+="</p>";

	SQLite3DB::Statement st=m_db->Prepare("SELECT COUNT(*) FROM tblMessageInserts WHERE Inserted='false';");
	st.Step();
	if(st.RowReturned())
	{
		st.ResultText(0,messagecountstr);
	}
	content+="Messages waiting to be inserted:"+messagecountstr+"<br>";
	st=m_db->Prepare("SELECT COUNT(*) FROM tblFileInserts WHERE Key IS NULL;");
	st.Step();
	if(st.RowReturned())
	{
		st.ResultText(0,filecountstr);
	}
	content+="Files waiting to be inserted:"+filecountstr+"<br>";

	content+="<p class=\"paragraph\">";
	content+="<form name=\"frmshutdown\" method=\"POST\">";
	content+="<input type=\"hidden\" name=\"formaction\" value=\"shutdown\">";
	content+="<input type=\"submit\" value=\"Shutdown FMS\">";
	content+="</form>";
	content+="</p>";

	return "HTTP/1.1 200 OK\r\nContent-Type: text/html\r\n\r\n"+StringFunctions::Replace(m_template,"[CONTENT]",content);
}

const bool HomePage::WillHandleURI(const std::string &uri)
{
	return true;
}
